Compare commits

...

210 commits

Author SHA1 Message Date
evilham 3ee742f0ab Kamila's changes +iocage_cone + tinydns* ~ __daemontools_service
Consider at some point whether or not they are worth upstreaming.
(also __pf_rdr belongs to this batch)
2020-04-26 17:54:36 +02:00
evilham 47e1267097 Merge branch 'master' into local 2020-04-26 16:42:30 +02:00
Darko Poljak 04b7f240eb ++changelog 2020-04-26 10:01:18 +02:00
poljakowski 8074f02bb3 Merge branch 'evilham-pf' into 'master'
[__pf*] (~) __pf_ruleset (+)__pf_apply_anchor, deprecate __pf_apply

See merge request ungleich-public/cdist!867
2020-04-26 09:59:24 +02:00
poljakowski 71156258a4 Merge branch 'evilham-postfix' into 'master'
[__postfix] Automagically support more OSs by not checking too much.

See merge request ungleich-public/cdist!866
2020-04-26 09:52:08 +02:00
poljakowski c13608fab5 Merge branch 'evilham-openldap_server' into 'master'
[__openldap_server] Support extra config parameter.

See merge request ungleich-public/cdist!865
2020-04-26 09:50:21 +02:00
poljakowski b40b95d758 Merge branch 'evilham-motd' into 'master'
[__motd] Improve documentation and support for FreeBSD

See merge request ungleich-public/cdist!864
2020-04-26 09:47:54 +02:00
poljakowski 6ec3274598 Merge branch 'postgres-database-args' into 'master'
Add --template, --encoding, --lc-collate, --lc-support to __postgres_database type

See merge request ungleich-public/cdist!859
2020-04-26 09:41:30 +02:00
poljakowski 80d204368a Merge branch 'fix-configuration-file-location' into 'master'
Fix configuration file location

See merge request ungleich-public/cdist!863
2020-04-26 09:33:38 +02:00
evilham 2928795441 [__pf_ruleset] Fix shellcheck issue. 2020-04-25 14:54:29 +02:00
evilham fefe90e9c9 [__pf*] (~) __pf_ruleset (+)__pf_apply_anchor, deprecate __pf_apply
__pf_apply the way it exists on cdist is not really useful and __pf_ruleset does
not take advantage of other types as it should, being instead overly complex and
not as reliable.

The new __pf_ruleset is compatible with the previous one, and __pf_apply_anchors
allows for a simple and powerful way of managing pf anchors.
The functionality previously provided by __pf_apply is still possible out of the
box in __pf_ruleset.

These patches were mostly contributed by Kamila Součková and made fit for
upstreaming by Evilham.
2020-04-25 12:23:27 +02:00
evilham cd6c02d16c Add copyright notice and make consistent with other types 2020-04-25 01:29:17 +02:00
evilham 5981d0a5f1 [__postfix] Automagically support more OSs by not checking too much.
It is quite likely that the package is going to be called postfix, rather
than trying to have an exhaustive "allow list" for this package, we can
just add special cases for OSs where that is not the case (not aware of any
atm).
2020-04-25 00:22:28 +02:00
evilham 056c7c5400 [__openldap_server] Support extra config parameter.
This allows the user to, e.g. manually define ACLs, while this type does not
support that.
2020-04-25 00:12:24 +02:00
evilham 9e5c8a2524 Merge branch 'to-upstream' into local 2020-04-24 20:28:11 +02:00
evilham de37b0ce45 [__motd] Improve documentation and support for FreeBSD
This makes it easier to use the type just by reading the man page and also
treats FreeBSD's MOTD better.
2020-04-24 20:26:44 +02:00
evilham 6cb0afdb9f Changes changes 2020-04-24 13:29:43 +02:00
Darko Poljak 41e59a748d Fix newly found shellcheck issues 2020-04-22 23:24:34 +02:00
Darko Poljak 38ccdfda32 Fix newly found shellcheck issues 2020-04-22 23:21:34 +02:00
fnux e2b26aa233 Patch CI configuration to use cdist-ci image 2020-04-21 08:16:46 +02:00
fnux 7d57655470 Fix typo in cdist-ci image README 2020-04-21 08:15:51 +02:00
fnux c9c1e7d790 Import CI image definition 2020-04-21 08:13:32 +02:00
sparrowhawk 742163e38c Fix configuration file location 2020-04-15 17:10:33 +02:00
fnux c3f924d350 Add --template flag to __postgres_database type 2020-04-14 10:23:08 +02:00
Darko Poljak 0805fac7e9 Release 6.5.4 2020-04-11 20:35:29 +02:00
Darko Poljak d1eecb93ee ++changelog 2020-04-11 20:30:56 +02:00
poljakowski 8af4f7993c Merge branch 'preserve-conf-dir-sort-order' into 'master'
remove duplicates from conf dirs while preserving order

See merge request ungleich-public/cdist!862
2020-04-11 20:30:11 +02:00
Darko Poljak 704e78322e Use OrderedDict to guarantee order
Note:
> Changed in version 3.7: Dictionary order is guaranteed to be
> insertion order. This behavior was an implementation detail of
> CPython from 3.6.
2020-04-11 20:26:20 +02:00
Darko Poljak 1ebcc219c2 ++changelog 2020-04-11 09:54:57 +02:00
Steven Armstrong e19c1bb1e0 remove duplicates from conf dirs while preserving order
Signed-off-by: Steven Armstrong <steven@icarus.ethz.ch>
2020-04-10 21:50:39 +02:00
Steven Armstrong 76d978d3d8 explorer/init: do not grep on non-existent init
Signed-off-by: Steven Armstrong <steven@icarus.ethz.ch>
2020-04-10 10:51:17 +02:00
fnux d53077f4e8 Add --encoding, --lc-collate, --lc-support to __postgres_database type 2020-04-06 09:30:01 +02:00
Darko Poljak ceb6b597ef Release 6.5.3 2020-04-03 19:45:44 +02:00
Darko Poljak 890c73f6bd Fix shellcheck issues 2020-04-02 20:18:04 +02:00
Nico Schottelius d034fe9369 [__pyvenv] use python3 -m venv on alpine
Until python4 comes, this will work
2020-04-02 18:24:13 +02:00
Nico Schottelius 0f639a9278 Make __cron nonparallel
It fails due to removal / edit of crontab at the same time

VERBOSE: [18331]: uncloud.ungleich.ch: Running object __cron/pg_dump_cleanup
VERBOSE: [18332]: uncloud.ungleich.ch: Running object __ungleich_packages/server
VERBOSE: [18335]: uncloud.ungleich.ch: Running object __postgres_role/app
INFO: [18335]: uncloud.ungleich.ch: Processing __postgres_role/app
INFO: [18331]: uncloud.ungleich.ch: Processing __cron/pg_dump_cleanup
ERROR: [16451]: uncloud.ungleich.ch: ssh -o User=root -o ControlPath=/tmp/tmp_8eu4oep/s -o ControlMaster=auto -o ControlPersist=2h uncloud.ungleich.ch /bin/sh -c ' export __object=/var/lib/cdist/object/__cron/pg_dumpall_under_day/.cdist-mfd00npk;  export __object_id=pg_dumpall_under_day;/bin/sh -e /var/lib/cdist/object/__cron/pg_dumpall_under_day/.cdist-mfd00npk/code-remote': ['ssh', '-o', 'User=root', '-o', 'ControlPath=/tmp/tmp_8eu4oep/s', '-o', 'ControlMaster=auto', '-o', 'ControlPersist=2h', 'uncloud.ungleich.ch', "/bin/sh -c ' export __object=/var/lib/cdist/object/__cron/pg_dumpall_under_day/.cdist-mfd00npk;  export __object_id=pg_dumpall_under_day;/bin/sh -e /var/lib/cdist/object/__cron/pg_dumpall_under_day/.cdist-mfd00npk/code-remote'"]

Error processing object '__cron/pg_dumpall_under_day'
=====================================================
name: __cron/pg_dumpall_under_day
path: /tmp/tmplaq9cwdh/6318c251013a449595327745daacf3ee/data/object/__cron/pg_dumpall_under_day/.cdist-mfd00npk
source: /tmp/tmplaq9cwdh/6318c251013a449595327745daacf3ee/data/conf/type/__ungleich_postgresql/manifest
type: /home/nico/vcs/cdist/cdist/conf/type/__cron

code-remote:stderr
------------------
crontab: can't move 'postgres.new' to 'postgres': No such file or directory

VERBOSE: [16451]: config: Total processing time for 1 host(s): 13.98031210899353
[18:09] line:~%
2020-04-02 18:14:09 +02:00
Darko Poljak da30afe791 ++changelog 2020-03-29 12:54:02 +02:00
poljakowski 1eb02f908b Merge branch 'fix/__package_update_index' into 'master'
[__package_update_index] Fix maxage false-positives on brand-new installations

See merge request ungleich-public/cdist!858
2020-03-29 13:53:55 +02:00
Darko Poljak b25939cdd6 Fix shellcheck 2020-03-27 13:30:52 +01:00
Darko Poljak df63cfe088 ++changelog 2020-03-27 08:50:27 +01:00
poljakowski 11148995d1 Merge branch 'master' into 'master'
fix typo

See merge request ungleich-public/cdist!857
2020-03-27 08:50:29 +01:00
Nico Schottelius ec11f04ab8 ++changes 2020-03-26 21:49:43 +01:00
Nico Schottelius 66d9905029 [__consul_agent] make conf_dir depent on the OS 2020-03-26 21:48:17 +01:00
andrewschleifer f00e4af5f0 fix typo 2020-03-26 21:17:32 +08:00
evilham 9fdc9082f4 [__letsencrypt_acmetiny] fix spellcheck warnings (bugs!) 2020-03-23 12:35:54 +01:00
evilham 1bd19d6dee [__letsencrypt_acmetiny] Simpler alternative to certbot.
This is inspired heavily by `debops.pki` in the https://debops.org project.
However there are several simplifications to their way of doing it.
2020-03-23 12:26:59 +01:00
matze 358e04b2af Handle specially if no time about the last index update found.
The explorer 'currage' now returns -1 if he can not find any value about
this. The gencode-remote script handle this value special to not exit if
-1 given as value.

This fixes the bug
  ungleich-public/cdist#803
2020-03-14 09:58:38 +01:00
Darko Poljak f7d5f5bc97 ++changelog 2020-03-09 08:02:18 +01:00
poljakowski 4481052184 Merge branch 'alpinefix' into 'master'
Fix for alpine "getent shadow" missing functionality in __user type

See merge request ungleich-public/cdist!855
2020-03-09 08:03:34 +01:00
llnu fb32d6ed3f alpine uses a different getent lib which doesnt support: getent shadow 2020-03-08 16:04:02 +01:00
Darko Poljak 213f1b049c Release 6.5.2 2020-02-27 20:23:04 +01:00
Darko Poljak da6ccf808e ++changelog 2020-02-26 21:48:08 +01:00
poljakowski 4b24d886eb Merge branch 'file/better-errors' into 'master'
[__file] Better errors analogous to __directory

See merge request ungleich-public/cdist!854
2020-02-26 21:50:01 +01:00
Dennis Camera 9eacba06bb [__file] Treat pre-exists as a special case in gencode-remote as it should never get there 2020-02-26 16:48:14 +01:00
Dennis Camera 46d2487f08 [__file] Give more precise error message when --state pre-exists 2020-02-26 16:40:53 +01:00
Darko Poljak 046f7d0663 ++changelog 2020-02-26 16:32:03 +01:00
poljakowski dd6b07d924 Merge branch 'directory-exists' into 'master'
[__directory] Add --state exists and --state pre-exists

See merge request ungleich-public/cdist!832
2020-02-26 16:33:37 +01:00
Dennis Camera 6b4b6534a1 [__directory] Give more precise error message when --state pre-exists 2020-02-26 16:15:23 +01:00
Darko Poljak b2db864eaf ++changelog 2020-02-26 13:01:29 +01:00
poljakowski aa49afd61a Merge branch 'fix/explorer/disks' into 'master'
explorer/disks: Fix on NetBSD and support Linux w/o lsblk

See merge request ungleich-public/cdist!852
2020-02-26 12:53:26 +01:00
Dennis Camera 6db6dc4ac0 [explorer/disks] Add license header 2020-02-25 20:24:14 +01:00
Dennis Camera 1ef126e16f [explorer/disks] Move xargs call to the bottom 2020-02-25 20:21:35 +01:00
Dennis Camera d3bd2669ec [explorer/disks] Support Linux without lsblk (fallback to sysfs) 2020-02-25 20:21:14 +01:00
poljakowski 0c49a0afda Merge branch 'consul-alpine' into 'master'
Add support for alpine (edge) package to __consul_agent

See merge request ungleich-public/cdist!851
2020-02-24 09:54:56 +01:00
fnux e6f683b886 Add support for alpine (edge) package to __consul_agent 2020-02-24 09:20:49 +01:00
Dennis Camera c6aba8d189 [explorer/disks] Fix for NetBSD
When connecting over SSH and running /bin/sh, the PATH is missing sbin locations.
sysctl is located at /sbin/sysctl on NetBSD.
2020-02-23 22:59:41 +01:00
Darko Poljak 49fc21ec47 ++changelog 2020-02-23 09:32:03 +01:00
poljakowski 47ec9ada10 Merge branch 'consul_agent' into 'master'
Refactor __consul_* for use with distribution packages

See merge request ungleich-public/cdist!837
2020-02-23 09:28:24 +01:00
poljakowski e1b80f7222 Merge branch 'service' into 'master'
Add simple __service type

See merge request ungleich-public/cdist!847
2020-02-23 09:21:29 +01:00
poljakowski 2a5309b413 Merge branch 'fix/init-explorer/busybox' into 'master'
[explorer/init] Support more init systems

See merge request ungleich-public/cdist!850
2020-02-23 09:18:51 +01:00
Dennis Camera 0d6bc8e8f8 [explorer/init] Make shellcheck happy 2020-02-20 23:34:19 +01:00
Dennis Camera 0d84c91b40 [explorer/init] Fix unique() for Solaris 2020-02-20 23:34:19 +01:00
Dennis Camera 364340c8d5 [explorer/init] Refactor and testing 2020-02-20 23:34:19 +01:00
Dennis Camera d895bb0e87 [explorer/init] Clean up 2020-02-20 23:34:19 +01:00
Dennis Camera 21c9e3db18 [explorer/init] Support more init systems 2020-02-20 23:34:11 +01:00
Nico Schottelius ceddbd15a0 ++changes 2020-02-20 10:15:34 +01:00
nico14571 2135381038 Merge branch 'master' into 'master'
[cdist]Update os_version for alpine

See merge request ungleich-public/cdist!849
2020-02-20 10:13:40 +01:00
kjg 28d3760e29 [cdist]Update os_version for alpine 2020-02-20 09:40:55 +01:00
Darko Poljak 1b0caeda13 ++changelog 2020-02-19 14:49:35 +01:00
poljakowski 44700424ba Merge branch '__update_alternatives_with_explorer' into 'master'
__update_alternatives: add state explorer

See merge request ungleich-public/cdist!848
2020-02-19 14:51:48 +01:00
ander a3bc8f9407 __update_alternatives: remove expired comment 2020-02-19 12:59:14 +02:00
ander b891bb05d5 __update_alternatives: add state explorer 2020-02-19 12:58:22 +02:00
fnux 09540dc6bd Add simple __service type 2020-02-17 21:38:03 +01:00
fnux 31ad1bdaad Fix various typos and styling errors in __consul_agent, conf-dir
explorer
2020-02-17 13:43:18 +01:00
fnux f595664924 Patch __consul_* to discover remote consul configuration dir 2020-02-17 13:42:19 +01:00
fnux 70200cd28f Refactor __consul_agent type to support distribution packages 2020-02-17 13:42:19 +01:00
Darko Poljak c09165d122 Fix spelling 2020-02-15 21:05:24 +01:00
Darko Poljak 0640b02f90 Fix too short title underline 2020-02-15 14:59:12 +01:00
Darko Poljak 9f3747cf3f Release 6.5.1 2020-02-15 14:36:26 +01:00
Darko Poljak cda77e5e8a ++changelog 2020-02-15 14:35:29 +01:00
poljakowski 7acbc8709b Merge branch 'postgres-role-password' into 'master'
Fix password command synthax in __postgres_role

See merge request ungleich-public/cdist!845
2020-02-15 14:36:54 +01:00
fnux a1536933ab Fix password command synthax in __postgres_role 2020-02-15 14:16:00 +01:00
Darko Poljak 58841fc4bf ++changelog 2020-02-15 12:20:41 +01:00
poljakowski 221c3820ca Merge branch 'type/__systemd_service' into 'master'
[__systemd_service] new type to manage the state of systemd services

See merge request ungleich-public/cdist!844
2020-02-15 12:22:04 +01:00
poljakowski b898412faf Merge branch 'fix/__cron' into 'master'
[__cron] Fix cronjob removal if `is` and `should` don't match

See merge request ungleich-public/cdist!841
2020-02-15 12:16:58 +01:00
matze ef089d1c61 [__systemd_service] new type to manage the state of systemd services 2020-02-15 11:42:01 +01:00
matze 5e6e17b3e5 Moved default parameter values from scripts to cdist parameter handling.
For more generalisation, the default parameter values are now handled by
cdist instead of trying to get a value and use a default if parameter is
not given.

It handles the default values in a more general way, instead of write
one default in (possibly) multiple places.
Problem occurred when checking the 'state' parameter, which required to
set a default value in two places.
2020-02-15 09:46:23 +01:00
matze a761d4842c Add check for the state parameter in manifest.
This only allow following cases:
  - present
  - absent
else, it will abort with an error message.
2020-02-15 08:21:24 +01:00
Darko Poljak 48bff66563 ++changelog 2020-02-14 21:55:35 +01:00
poljakowski c8dbd0718e Merge branch '__package_apt_updates_index' into 'master'
__package_apt: update index cache, on installation, when it is older than one day

See merge request ungleich-public/cdist!842
2020-02-14 21:57:04 +01:00
ander 869a38676f __package_apt: add comment about package index update 2020-02-14 19:22:06 +02:00
ander 1be5a9d316 __package_apt: add note about updating index 2020-02-14 19:19:12 +02:00
Darko Poljak e5f9d32004 ++changelog 2020-02-14 16:07:06 +01:00
poljakowski c4f085e739 Merge branch '__mysql_privileges_fix' into 'master'
__mysql_privileges: fix quoting

See merge request ungleich-public/cdist!843
2020-02-14 16:07:30 +01:00
ander f771840178 __mysql_privileges: fix typo 2020-02-13 17:38:34 +02:00
ander b7483d73eb __mysql_privileges: fix shellcheck 2020-02-13 17:38:19 +02:00
ander 710e99f240 __mysql_privileges: fix quoting 2020-02-13 17:29:44 +02:00
Nico Schottelius bcefeb240c add note about IPv6, because people ask 2020-02-10 15:51:15 +01:00
ander b3bad9468d __package_apt: pkgcache.bin may not exist 2020-02-09 20:43:09 +02:00
ander 08d5814e2c __package_apt: update index cache, on installation, when it is older than one day 2020-02-09 20:37:06 +02:00
Darko Poljak 7a5d6d5a7d ++changelog 2020-02-04 07:45:04 +01:00
poljakowski 0edda3b528 Merge branch 'no-stat-patch' into 'master'
__file/__directory: Patch for systems without stat(1)

See merge request ungleich-public/cdist!839
2020-02-04 07:46:28 +01:00
poljakowski 6291352136 Merge branch 'os-release-fallbacks' into 'master'
explorer/os_release: Add fallbacks

See merge request ungleich-public/cdist!840
2020-02-04 07:37:14 +01:00
Dennis Camera 984e0dc8c4 [explorer/os_release] Add fallbacks to /usr/lib/os-release and /var/run/os-release 2020-02-03 19:29:04 +01:00
Dennis Camera 3b5433d63a [__directory] stat explorer patch for systems without stat(1)
Some embedded systems (like OpenWrt) do not ship a stat(1) binary.
This workaround parses the output of ls(1) and /etc/passwd, /etc/group to
gather the information needed.
2020-02-03 18:36:59 +01:00
Dennis Camera e82dd35869 [__file] stat explorer patch for systems without stat(1)
Some embedded systems (like OpenWrt) do not ship a stat(1) binary.
This workaround parses the output of ls(1) and /etc/passwd, /etc/group to
gather the information needed.
2020-02-03 18:36:59 +01:00
Nico Schottelius 0f420993e1 ++ changelog update 2020-02-03 17:45:34 +01:00
Nico Schottelius 2d8afe0d16 Merge branch 'master' of code.ungleich.ch:ungleich-public/cdist 2020-02-03 17:44:55 +01:00
Nico Schottelius f3237e5d76 [consul agent] add support for Debian 10 2020-02-03 17:44:47 +01:00
matze e5d86ffc93 Fix to remove cronjobs when the cronjob expression did not match. 2020-02-01 17:08:25 +01:00
Dennis Camera 4fe2dcba89 [explorer/init] Linux is a mess... 2020-01-30 18:35:50 +01:00
Dennis Camera de1a421b68 [explorer/init] Support for Darwin and more BusyBox combinations 2020-01-30 18:04:00 +01:00
Darko Poljak 87f30b6053 Update sphinx docs copyright year 2020-01-23 14:40:07 +01:00
Darko Poljak 8f12a4c505 Release 6.5.0 2020-01-23 07:11:55 +01:00
Darko Poljak 4e8ccd9b78 ++changelog 2020-01-20 09:08:55 +01:00
poljakowski f7a5ac5f7a Merge branch '__acl_file_directory_params' into 'master'
__acl: add --file and --directory for convenience

See merge request ungleich-public/cdist!836
2020-01-20 09:10:07 +01:00
ander 1fbd2fc2bd __acl: add --file and --directory for convenience 2020-01-19 22:51:40 +02:00
Darko Poljak 5089f9055e ++changelog 2020-01-19 19:41:26 +01:00
poljakowski 138a449008 Merge branch '__acl_source_parameter' into 'master'
__acl: add --source

See merge request ungleich-public/cdist!835
2020-01-19 19:36:33 +01:00
ander e1ac97b6a5 __acl: add --source 2020-01-19 14:02:00 +02:00
Darko Poljak 45890cc7e4 ++changelog 2020-01-17 18:14:49 +01:00
Darko Poljak ffb3c003ca Merge branch 'ssrq/cdist-line-patches' 2020-01-17 18:07:14 +01:00
Darko Poljak e292c9f124 ++changelog 2020-01-17 15:48:59 +01:00
poljakowski efdeab61f3 Merge branch '__apt_unattended_upgrades' into 'master'
__apt_unattended_upgrades

See merge request ungleich-public/cdist!828
2020-01-17 15:50:07 +01:00
poljakowski a518134bfa Merge branch 'master' into 'master'
__postgres_*: fix forgotten edge cases in delimited identifier escape

See merge request ungleich-public/cdist!833
2020-01-17 15:48:00 +01:00
ander 65c5b592a5 __apt_unattended_upgrades: update manual 2020-01-17 14:48:54 +02:00
ander 6097cd9e90 __apt_unattended_upgrades: use word expansions 2020-01-17 14:41:00 +02:00
fnux ef2f4b9a00 __postgres_*: fix forgotten edge cases in delimited identifier escape 2020-01-17 11:24:24 +01:00
ander 6fa0d687f7 __apt_unattended_upgrades: alternative approach 2020-01-16 01:13:27 +02:00
ander f5f70671cb __apt_unattended_upgrades: make parameters more speaking 2020-01-16 00:59:03 +02:00
Dennis Camera 5a9a1ba57f [__line] Produce error when file does not exist 2020-01-15 22:00:56 +01:00
ander b3f36dbe5b __apt_unattended_upgrades: fix typo 2020-01-15 20:51:47 +02:00
ander cd24a806e7 __apt_unattended_upgrades: rewrite manifest, add more parameters 2020-01-15 20:48:32 +02:00
Dennis Camera 2cf44c66d4 [__directory] Add --state exists and --state pre-exists 2020-01-15 19:00:30 +01:00
ander 68e5502fce __apt_unattended_upgrades: move debian wiki link to manual 2020-01-15 19:27:02 +02:00
ander cd2d5b3f79 __apt_unattended_upgrades: all objects depend on package 2020-01-15 19:24:21 +02:00
Dennis Camera 51b1b11cc2 [__line/state] Logic fixes in explorer
This commit fixes the incorrectly reported state "wrongposition" if position is
"after" and anchor is present in the file but the line missing.
2020-01-15 17:57:45 +01:00
Dennis Camera 4cdb8aaa03 [__line/state] Make sure the index match is at the beginning
Without the == 1 all lines which contain --line as a substring match.  e.g. if
--line is "line" and the file contains the line "wrong line" this was considered
a match.
2020-01-15 17:50:43 +01:00
Dennis Camera 629d0795c8 [__line] Always add line to end if anchor is not found 2020-01-15 17:27:25 +01:00
Dennis Camera 93ec4b46aa [__line] Ensure the line is only added once 2020-01-15 17:27:25 +01:00
Darko Poljak 3258fc98e1 Fix typo 2020-01-12 12:19:49 +01:00
Darko Poljak 3f133dbc17 Info command: support tilde expansion 2020-01-11 15:26:46 +01:00
Darko Poljak 11f569959d Fix missing configuration file usage, support -g
PreOS code did not use configuration support. This fix adds support
for using cdist configuration, which takes into account cdist
configuration file, environment variables and command line options,
especially conf_dir.

It also adds support for -g, --config-file option, for specifying
custom configuration file.
2020-01-11 14:16:33 +01:00
Darko Poljak 51ba4a49d8 ++changelog 2020-01-04 18:21:23 +01:00
poljakowski b1e24881ce Merge branch '__acl_rename_param' into 'master'
__acl: rename --acl to --entry for the sake of consistency, add compatibility

See merge request ungleich-public/cdist!829
2020-01-04 18:20:56 +01:00
ander d4bd49bbb5 __acl: rename --acl to --entry for the sake of consistency, add compatibility 2020-01-04 17:43:57 +02:00
ander ec8d9571f9 __apt_unattended_upgrades: add manual 2020-01-04 17:07:46 +02:00
ander a9d491f998 __apt_unattended_upgrades: add license header 2020-01-04 16:59:42 +02:00
ander 94e32dcd78 __apt_unattended_upgrades: initial commit 2020-01-04 16:36:44 +02:00
Darko Poljak d1a64596fe Update build-helper 2020-01-04 14:56:05 +01:00
Darko Poljak 7c9dd3b03e Release 6.4.0 2020-01-04 14:36:14 +01:00
Darko Poljak bc1990c7c8 ++changelog 2020-01-04 13:44:04 +01:00
poljakowski 1fc845480e Merge branch '__mysql' into 'master'
rewrite __mysql_database, add types __mysql_user and __mysql_privileges

See merge request ungleich-public/cdist!827
2020-01-04 13:45:15 +01:00
Darko Poljak e201536792 ++changelog 2020-01-04 13:18:13 +01:00
Darko Poljak 7b1192257d Fix incomplete cdist info synopsis 2020-01-04 13:17:54 +01:00
poljakowski 9b2e273bd1 Merge branch 'feature/info-command' into 'master'
Add cdist info command

See merge request ungleich-public/cdist!825
2020-01-04 13:16:49 +01:00
Darko Poljak e4596593c0 Add cdist info command 2020-01-04 12:50:12 +01:00
Darko Poljak 72935e0a79 ++changelog 2020-01-04 11:08:48 +01:00
Darko Poljak 6369bc1ae5 ++changelog 2020-01-04 10:07:53 +01:00
poljakowski c51571b47f Merge branch 'master' into 'master'
__postgres_*: use delimited identifiers (double quoted) in generated SQL

See merge request ungleich-public/cdist!826
2020-01-04 10:09:07 +01:00
ander 4329cced82 __mysql_privileges: add manual 2020-01-03 18:55:55 +02:00
ander 5e8dc7122d __mysql_user: add manual 2020-01-03 18:48:11 +02:00
ander fcc774cb7b __mysql_database: add manual 2020-01-03 18:33:23 +02:00
ander 24862e0208 __mysql_database: carry over state 2020-01-03 18:26:11 +02:00
ander 9a693537f4 __mysql_*: add license headers 2020-01-01 12:38:12 +02:00
ander c32e4040b1 __mysql_*: initial rewrite 2019-12-31 19:16:49 +02:00
fnux beb930c0dc __postgres_*: use delimited identifiers (double quoted) in generated SQL 2019-12-31 11:34:51 +01:00
Steven Armstrong df05abd15b bugfix: __install_chroot_umount was not using __chroot_umount/manifest
Signed-off-by: Steven Armstrong <steven@icarus.ethz.ch>
2019-12-19 12:33:47 +01:00
Nico Schottelius f407e8825f [consul/alpine] no init script required to be deployed anymore 2019-12-15 22:56:16 +01:00
Darko Poljak 9859080217 Release 6.3.0 2019-12-12 07:43:07 +01:00
Darko Poljak 8562871da9 Fix shellcheck exit status
shellcheck* targets were always reporting exit status 0.
With this fix, if shellcheck fails, then build-helper script
exits with 1.
2019-12-12 07:37:32 +01:00
Darko Poljak bd4eee7925 Fix shellcheck reported issues 2019-12-12 07:37:32 +01:00
Darko Poljak 2c7b4ddc55 Update cdist man page 2019-12-12 06:18:04 +01:00
Darko Poljak 3c62a88ca7 ++changelog 2019-12-10 19:33:29 +01:00
poljakowski c58c4b8309 Merge branch 'evilham-openldap' into 'master'
[new-type] __openldap_server

See merge request ungleich-public/cdist!822
2019-12-10 19:33:33 +01:00
poljakowski 3bdc731e4f Merge branch 'master' into 'master'
[type-docs] __start_on_boot: remove unspported *BSD claim.

See merge request ungleich-public/cdist!823
2019-12-10 19:32:21 +01:00
evilham 3ba230c10d [type-docs] __start_on_boot: remove unspported *BSD claim.
The type appears to support {Open,Free}BSD properly.
2019-12-10 13:12:54 +01:00
evilham 35f0d4dbfa [new-type] __openldap_server: another documentation typo. 2019-12-10 13:10:19 +01:00
evilham 79d58f0813 [new-type] __openldap_server: fix docs / dependency.
It's nicer to have slapd_flags after slapd_enable in rc.conf on freebsd.
2019-12-10 13:04:24 +01:00
evilham 22c5cd550b [new-type] __openldap_server: first public version.
This already takes care of setting up the base DN and managing it as well as
allowing for settings for the listener URLS.

The type was also made a singleton as it doesn't make much sense to setup
multiple LDAP servers on the same machine.
2019-12-10 12:49:07 +01:00
evilham 42914d26c5 [new-type] __openldap_server: sudo make nico.happy. 2019-12-09 19:59:15 +01:00
evilham 1ad605a509 [new-type] __openldap_server: Add admin-email parameter. 2019-12-09 19:49:05 +01:00
evilham fd430eab62 [new-type] __openldap_server: Add a "schema" optional parameter. 2019-12-09 19:39:43 +01:00
evilham bee95efa43 [new-type] __openldap_server
Originally developed at ungleich and improved for Open Sourcing by Evilham.
2019-12-09 19:13:10 +01:00
Darko Poljak 553cfc28e7 ++changelog 2019-12-09 09:57:54 +01:00
poljakowski 27b682bfe9 Merge branch 'preos-plugins-dir-opt' into 'master'
Add conf-dir preos option

Closes #794

See merge request ungleich-public/cdist!821
2019-12-09 09:56:10 +01:00
Darko Poljak 4735df1bed Add plugins-dir preos option 2019-12-09 09:48:12 +01:00
Darko Poljak d5ac9ea348 Docs: install from source, verify signature
Add chapter for installing from source with signature verification.
Resolves #795.
2019-12-08 16:35:41 +01:00
Darko Poljak 839e7a408e ++changelog 2019-12-06 19:46:17 +01:00
poljakowski fb97574592 Merge branch 'master' into 'master'
[docs] PreOS: English nitpicking

See merge request ungleich-public/cdist!820
2019-12-06 19:46:29 +01:00
Darko Poljak f2cbc01e3f ++changelog 2019-12-06 10:04:06 +01:00
Darko Poljak 71b6646b38 Rm cdist-type prefix and man page ref from docs
E.g.

16.10. __block
16.11. __ccollect_source
16.12. __cdist
16.13. __cdistmarker
16.14. __check_messages

insted of

16.10. cdist-type__block(7)
16.11. cdist-type__ccollect_source(7)
16.12. cdist-type__cdist(7)
16.13. cdist-type__cdistmarker(7)
16.14. cdist-type__check_messages(7)
2019-12-06 10:00:32 +01:00
Darko Poljak 90e85d8128 Embed config skeleton instead of rewriting it
Resolves #796.
2019-12-06 09:37:21 +01:00
Darko Poljak f22349ce8a Fix documentation for install types
Fixes gitlab #790.
2019-12-06 09:00:16 +01:00
evilham 58cbe53e61 Merge branch 'master' of https://code.ungleich.ch/ungleich-public/cdist 2019-12-05 23:15:11 +01:00
evilham 4f21bf534d [docs] PreOS: English nitpicking. 2019-12-05 23:14:27 +01:00
Darko Poljak 320f962e1d ++changelog 2019-12-04 22:27:58 +01:00
poljakowski 05221e2159 Merge branch 'b/alpine-package-update-index' into 'master'
[PACKAGE-UPDATE-INDEX]: Bugfix of the alpine part of the __package_update_index type

See merge request ungleich-public/cdist!818
2019-12-04 22:28:42 +01:00
Dominique Roux d25c72e678 [PACKAGE-UPDATE-INDEX]: Bugfix of the alpine part of the __package_update_index type 2019-12-03 10:13:46 +01:00
Darko Poljak 8c0ee28b99 gitlab CI runner should have necessary tools 2019-12-02 12:35:43 +01:00
186 changed files with 4256 additions and 785 deletions

2
.gitignore vendored
View file

@ -24,6 +24,8 @@ docs/src/man1/*.1
docs/src/man7/*.7
docs/src/man7/cdist-type__*.rst
docs/src/cdist-reference.rst
docs/src/cdist-types.rst
docs/src/cdist.cfg.skeleton
# Ignore cdist cache for version control
/cache/

View file

@ -1,28 +1,20 @@
stages:
- test
image: code.ungleich.ch:5050/ungleich-public/cdist/cdist-ci:latest
unit_tests:
stage: test
before_script:
- 'apk update'
- 'apk add python3'
script:
- ./bin/build-helper version
- ./bin/build-helper test
pycodestyle:
stage: test
before_script:
- 'apk update'
- 'apk add python3 py3-pycodestyle'
- 'ln -f -s /usr/bin/pycodestyle-3 /usr/bin/pycodestyle'
script:
- ./bin/build-helper pycodestyle
shellcheck:
stage: test
before_script:
- 'wget https://storage.googleapis.com/shellcheck/shellcheck-stable.linux.x86_64.tar.xz'
- 'tar xf shellcheck-stable.linux.x86_64.tar.xz && mv shellcheck-stable/shellcheck /usr/bin/'
script:
- ./bin/build-helper shellcheck

View file

@ -63,6 +63,18 @@ DOCSREFSH=$(DOCS_SRC_DIR)/cdist-reference.rst.sh
$(DOCSREF): $(DOCSREFSH)
$(DOCSREFSH)
# Html types list with references
DOCSTYPESREF=$(MAN7DSTDIR)/cdist-types.rst
DOCSTYPESREFSH=$(DOCS_SRC_DIR)/cdist-types.rst.sh
$(DOCSTYPESREF): $(DOCSTYPESREFSH)
$(DOCSTYPESREFSH)
DOCSCFGSKEL=./configuration/cdist.cfg.skeleton
configskel: $(DOCSCFGSKEL)
cp -f "$(DOCSCFGSKEL)" "$(DOCS_SRC_DIR)/"
version:
@[ -f "cdist/version.py" ] || { \
printf "Missing 'cdist/version.py', please generate it first.\n" && exit 1; \
@ -72,7 +84,7 @@ version:
man: version $(MANTYPES) $(DOCSREF)
$(SPHINXM)
html: version $(MANTYPES) $(DOCSREF)
html: version configskel $(MANTYPES) $(DOCSREF) $(DOCSTYPESREF)
$(SPHINXH)
docs: man html
@ -114,6 +126,8 @@ speeches: $(SPEECHES)
#
clean: docs-clean
rm -f $(DOCS_SRC_DIR)/cdist-reference.rst
rm -f $(DOCS_SRC_DIR)/cdist-types.rst
rm -f $(DOCS_SRC_DIR)/cdist.cfg.skeleton
find "$(DOCS_SRC_DIR)" -mindepth 2 -type l \
| xargs rm -f

View file

@ -74,6 +74,7 @@ SHELLCHECKCMD="shellcheck -s sh -f gcc -x"
# Skip SC2154 for variables starting with __ since such variables are cdist
# environment variables.
SHELLCHECK_SKIP=': __.*is referenced but not assigned.*\[SC2154\]'
SHELLCHECKTMP=".shellcheck.tmp"
# Change to checkout directory
basedir="${0%/*}/../"
@ -369,7 +370,7 @@ eof
cat << eof
Manual steps post release:
- cdist-web
- send mail body generated in mailinglist.tmp and inform Dmitry for deb
- send generated mailinglist.tmp mail
- twitter
eof
;;
@ -431,53 +432,67 @@ eof
;;
shellcheck-global-explorers)
find cdist/conf/explorer -type f -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" || exit 0
# shellcheck disable=SC2086
find cdist/conf/explorer -type f -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" > "${SHELLCHECKTMP}"
test ! -s "${SHELLCHECKTMP}" || { cat "${SHELLCHECKTMP}"; exit 1; }
;;
shellcheck-type-explorers)
find cdist/conf/type -type f -path "*/explorer/*" -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" || exit 0
# shellcheck disable=SC2086
find cdist/conf/type -type f -path "*/explorer/*" -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" > "${SHELLCHECKTMP}"
test ! -s "${SHELLCHECKTMP}" || { cat "${SHELLCHECKTMP}"; exit 1; }
;;
shellcheck-manifests)
find cdist/conf/type -type f -name manifest -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" || exit 0
# shellcheck disable=SC2086
find cdist/conf/type -type f -name manifest -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" > "${SHELLCHECKTMP}"
test ! -s "${SHELLCHECKTMP}" || { cat "${SHELLCHECKTMP}"; exit 1; }
;;
shellcheck-local-gencodes)
find cdist/conf/type -type f -name gencode-local -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" || exit 0
# shellcheck disable=SC2086
find cdist/conf/type -type f -name gencode-local -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" > "${SHELLCHECKTMP}"
test ! -s "${SHELLCHECKTMP}" || { cat "${SHELLCHECKTMP}"; exit 1; }
;;
shellcheck-remote-gencodes)
find cdist/conf/type -type f -name gencode-remote -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" || exit 0
# shellcheck disable=SC2086
find cdist/conf/type -type f -name gencode-remote -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" > "${SHELLCHECKTMP}"
test ! -s "${SHELLCHECKTMP}" || { cat "${SHELLCHECKTMP}"; exit 1; }
;;
shellcheck-scripts)
${SHELLCHECKCMD} scripts/cdist-dump scripts/cdist-new-type || exit 0
# shellcheck disable=SC2086
${SHELLCHECKCMD} scripts/cdist-dump scripts/cdist-new-type > "${SHELLCHECKTMP}"
test ! -s "${SHELLCHECKTMP}" || { cat "${SHELLCHECKTMP}"; exit 1; }
;;
shellcheck-gencodes)
"$0" shellcheck-local-gencodes
"$0" shellcheck-remote-gencodes
"$0" shellcheck-local-gencodes || exit 1
"$0" shellcheck-remote-gencodes || exit 1
;;
shellcheck-types)
"$0" shellcheck-type-explorers
"$0" shellcheck-manifests
"$0" shellcheck-gencodes
"$0" shellcheck-type-explorers || exit 1
"$0" shellcheck-manifests || exit 1
"$0" shellcheck-gencodes || exit 1
;;
shellcheck)
"$0" shellcheck-global-explorers
"$0" shellcheck-types
"$0" shellcheck-scripts
"$0" shellcheck-global-explorers || exit 1
"$0" shellcheck-types || exit 1
"$0" shellcheck-scripts || exit 1
;;
shellcheck-type-files)
find cdist/conf/type -type f -path "*/files/*" -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" || exit 0
# shellcheck disable=SC2086
find cdist/conf/type -type f -path "*/files/*" -exec ${SHELLCHECKCMD} {} + | grep -v "${SHELLCHECK_SKIP}" > "${SHELLCHECKTMP}"
test ! -s "${SHELLCHECKTMP}" || { cat "${SHELLCHECKTMP}"; exit 1; }
;;
shellcheck-with-files)
"$0" shellcheck
"$0" shellcheck-type-files
"$0" shellcheck || exit 1
"$0" shellcheck-type-files || exit 1
;;
shellcheck-build-helper)
@ -535,6 +550,7 @@ eof
# Temp files
rm -f ./*.tmp
rm -f ./.*.tmp
;;
distclean)

View file

@ -6,6 +6,7 @@ import collections
import functools
import cdist.configuration
import cdist.preos
import cdist.info
# set of beta sub-commands
@ -103,7 +104,7 @@ def get_parsers():
name="log level"),
help=('Set the specified verbosity level. '
'The levels, in order from the lowest to the highest, are: '
'ERROR (-1), WARNING (0), INFO (1), VERBOSE (2), DEBUG (3) '
'ERROR (-1), WARNING (0), INFO (1), VERBOSE (2), DEBUG (3), '
'TRACE (4 or higher). If used along with -v then -v '
'increases last set value and -l overwrites last set '
'value.'),
@ -424,7 +425,7 @@ def get_parsers():
parser['inventory'].set_defaults(
func=cdist.inventory.Inventory.commandline)
# PreOs
# PreOS
parser['preos'] = parser['sub'].add_parser('preos', add_help=False)
# Shell
@ -436,6 +437,37 @@ def get_parsers():
' should be POSIX compatible shell.'))
parser['shell'].set_defaults(func=cdist.shell.Shell.commandline)
# Info
parser['info'] = parser['sub'].add_parser('info')
parser['info'].add_argument(
'-a', '--all', help='Display all info. This is the default.',
action='store_true', default=False)
parser['info'].add_argument(
'-c', '--conf-dir',
help='Add configuration directory (can be repeated).',
action='append')
parser['info'].add_argument(
'-e', '--global-explorers',
help='Display info for global explorers.', action='store_true',
default=False)
parser['info'].add_argument(
'-F', '--fixed-string',
help='Interpret pattern as a fixed string.', action='store_true',
default=False)
parser['info'].add_argument(
'-f', '--full', help='Display full details.',
action='store_true', default=False)
parser['info'].add_argument(
'-g', '--config-file',
help='Use specified custom configuration file.',
dest="config_file", required=False)
parser['info'].add_argument(
'-t', '--types', help='Display info for types.',
action='store_true', default=False)
parser['info'].add_argument(
'pattern', nargs='?', help='Glob pattern.')
parser['info'].set_defaults(func=cdist.info.Info.commandline)
for p in parser:
parser[p].epilog = EPILOG

View file

@ -1,27 +1,67 @@
#!/bin/sh
#!/bin/sh -e
#
# based on previous work by other people, modified by:
# 2020 Dennis Camera <dennis.camera at ssrq-sds-fds.ch>
#
# This file is part of cdist.
#
# cdist is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# cdist is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with cdist. If not, see <http://www.gnu.org/licenses/>.
#
# Finds disks of the system (excl. ram disks, floppy, cdrom)
uname_s="$(uname -s)"
case "${uname_s}" in
case $uname_s in
FreeBSD)
sysctl -n kern.disks
;;
OpenBSD|NetBSD)
sysctl -n hw.disknames | grep -Eo '[lsw]d[0-9]+' | xargs
OpenBSD)
sysctl -n hw.disknames | grep -Eo '[lsw]d[0-9]+'
;;
NetBSD)
PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
sysctl -n hw.disknames \
| awk 'BEGIN { RS = " " } /^[lsw]d[0-9]+/'
;;
Linux)
if command -v lsblk > /dev/null
# list of major device numbers toexclude:
# ram disks, floppies, cdroms
# https://www.kernel.org/doc/Documentation/admin-guide/devices.txt
ign_majors='1 2 11'
if command -v lsblk >/dev/null 2>&1
then
# exclude ram disks, floppies and cdroms
# https://www.kernel.org/doc/Documentation/admin-guide/devices.txt
lsblk -e 1,2,11 -dno name | xargs
lsblk -e "$(echo "$ign_majors" | tr ' ' ',')" -dno name
elif test -d /sys/block/
then
# shellcheck disable=SC2012
ls -1 /sys/block/ \
| awk -v ign_majors="$(echo "$ign_majors" | tr ' ' '|')" '
{
devfile = "/sys/block/" $0 "/dev"
getline devno < devfile
close(devfile)
if (devno !~ "^(" ign_majors "):") print
}'
else
printf "Don't know how to list disks for %s operating system without lsblk, if you can please submit a patch\n" "${uname_s}" >&2
echo "Don't know how to list disks on Linux without lsblk and sysfs." >&2
echo 'If you can, please submit a patch.'>&2
fi
;;
*)
printf "Don't know how to list disks for %s operating system, if you can please submit a patch\n" "${uname_s}" >&2
printf "Don't know how to list disks for %s operating system.\n" "${uname_s}" >&2
printf 'If you can please submit a patch\n' >&2
;;
esac
exit 0
esac \
| xargs

View file

@ -1,7 +1,8 @@
#!/bin/sh
#!/bin/sh -e
#
# 2016 Daniel Heule (hda at sfs.biz)
# Copyright 2017, Philippe Gregoire <pg@pgregoire.xyz>
# 2020 Dennis Camera (dennis.camera at ssrq-sds-fds.ch)
#
# This file is part of cdist.
#
@ -19,21 +20,423 @@
# along with cdist. If not, see <http://www.gnu.org/licenses/>.
#
#
# Returns the process name of pid 1 ( normaly the init system )
# for example at linux this value is "init" or "systemd" in most cases
# Returns the name of the init system (PID 1)
# Expected values:
# Linux:
# Adélie Linux:
# sysvinit+openrc
# Alpine Linux:
# busybox-init+openrc
# ArchLinux:
# systemd, sysvinit
# CRUX:
# sysvinit
# Debian:
# systemd, upstart, sysvinit, openrc, ???
# Devuan:
# sysvinit, sysvinit+openrc
# Gentoo:
# sysvinit+openrc, openrc-init, systemd
# OpenBMC:
# systemd
# OpenWrt:
# procd, init???
# RedHat (RHEL, CentOS, Fedora, RedHat Linux, ...):
# systemd, upstart, upstart-legacy, sysvinit
# Slackware:
# sysvinit
# SuSE:
# systemd, sysvinit
# Ubuntu:
# systemd, upstart, upstart-legacy, sysvinit
# VoidLinux:
# runit
#
# GNU:
# Debian:
# sysvinit, hurd-init
#
# BSD:
# {Free,Open,Net}BSD:
# init
#
# Mac OS X:
# launchd, init+SystemStarter
#
# Solaris/Illumos:
# smf, init???
uname_s="$(uname -s)"
# NOTE: init systems can be stacked. This is popular to run OpenRC on top of
# sysvinit (Gentoo) or busybox-init (Alpine), but can also be used to run runit
# as a systemd service. This makes init system detection very complicated
# (which result is expected?) This script tries to untangle some combinations,
# OpenRC on top of sysv or busybox (X+openrc), but will ignore others (runit as
# a systemd service)
case "$uname_s" in
Linux)
(pgrep -P0 -l | awk '/^1[ \t]/ {print $2;}') || true
;;
FreeBSD|OpenBSD)
ps -o comm= -p 1 || true
;;
*)
# return a empty string as unknown value
echo ""
;;
esac
# NOTE: When we have no idea, nothing will be printed!
# NOTE:
# When trying to gather information about the init system make sure to do so
# without calling the binary! On some systems this triggers a reinitialisation
# of the system which we don't want (e.g. embedded systems).
set -e
KERNEL_NAME=$(uname -s)
KNOWN_INIT_SYSTEMS=$(cat <<EOF
systemd
sysvinit
upstart
runit
procd
smf
launchd
init
hurd_init
systemstarter
EOF
)
common_candidates_by_kernel() {
case $KERNEL_NAME
in
FreeBSD|NetBSD|OpenBSD)
echo init
;;
Linux)
echo systemd